% Directory with original images
original_dir = fullfile(pwd,'Input_set_original');

% Directory with outputs of algortihms, each algorithm in a different
% subdirectory. File names in each subdirectory must be the same as the
% original images.
input_dir = fullfile(pwd,'Input_set');

% No-reference measure for graphs, one of {Ma, BRISQUE, NIQE}
no_ref_measure = 'NIQE';

% Number of pixels to shave of image borders when calcualting IQA scores
shave_width = 4;


%% Calculate IQA scores and plotting
addpath utils

% Calcualting IQA scores
alg_list = dir(input_dir); alg_list(1:2,:) = [];
scores_all = struct();
for ii=1:length(alg_list)
    alg_input_dir = fullfile(input_dir,alg_list(ii).name);
    scores_all.(alg_list(ii).name) = calc_IQA(alg_input_dir,original_dir,...
        no_ref_measure,shave_width);
    scores_all.(alg_list(ii).name).name = alg_list(ii).name;
end

% Plotting
plot_PD_plane_set(scores_all,no_ref_measure);